﻿/****************************************************
    文件：PreferenceData.cs
    作者：陶长春
    邮箱：376248129@qq.com
    日期：2025年2月11日 6:34:37
    UnityVersion: 2021.3.13f1
    功能：偏好设置数据
*****************************************************/
using System.Collections;
using UnityEngine;
using System.Collections.Generic;
namespace TFramework
{
    public class PreferenceData : ScriptableObject
    {
        public bool m_isAutoSave = false;

        public float m_autoSaveTime=5;

        /// <summary>
        /// 是否始终从Init场景运行
        /// </summary>
        public bool m_isAlwaysFormAssignScene;

        /// <summary>
        /// 指定启动场景
        /// </summary>
        public string m_assignScene;
    }
}