using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;

namespace TFramework
{
    public class OnAssetsEvent : UnityEditor.AssetModificationProcessor
    {
        /// <summary>
        /// Դɾ¼
        /// </summary>
        public static TAction<int> DeleteAssetEvent;

        /// <summary>
        /// Դƶ¼
        /// </summary>
        public static TAction<int> MoveAssetEvent;

        public static TAction<string> CreateAssetEvent;

        [InitializeOnLoadMethod]
        static void EditorApplication_projectChanged()
        {
            //--ȫּProjectͼµԴǷ仯 ɾ ƶȣ
            //EditorApplication.projectChanged += delegate ()
            //{
            //Debug.Log("Դ״̬仯");
            //};
        }
        //--˫Դ¼
        public static bool IsOpenForEdit(string assetPath, out string message)
        {
            message = null;
            return true;
        }
        //--Դ¼
        public static void OnWillCreateAsset(string path)
        {
            CreateAssetEvent?.Invoke(path);
        }
        //--Դ桱¼
        public static string[] OnWillSaveAssets(string[] paths)
        {
            if (paths != null)
            {
                //Debug.Log("Դ path :" + string.Join(",", paths));
            }
            return paths;
        }
        //--Դƶ¼
        public static AssetMoveResult OnWillMoveAsset(string oldPath, string newPath)
        {
            int id = GetInstanceID(oldPath);
            MoveAssetEvent?.Invoke(id);
            return AssetMoveResult.DidNotMove;
        }

        /// <summary>
        /// -- Դɾ¼
        /// </summary>
        /// <param name="assetPath"></param>
        /// <param name="option"></param>
        /// <returns></returns>
        public static AssetDeleteResult OnWillDeleteAsset(string assetPath, RemoveAssetOptions option)
        {
            int id = GetInstanceID(assetPath);
            DeleteAssetEvent?.Invoke(id);
            return AssetDeleteResult.DidNotDelete;
        }

        /// <summary>
        /// ȡԴID
        /// </summary>
        /// <param name="assetPath">Դ·</param>
        /// <returns></returns>
        static int GetInstanceID(string assetPath)
        {
            Object obj = AssetDatabase.LoadMainAssetAtPath(assetPath);
            return obj == null ? -1 : obj.GetInstanceID();
        }
        /// <summary>
        /// Դ
        /// </summary>
        public enum ProtectType
        {
            /// <summary>
            /// ɾ
            /// </summary>
            Delete,
            /// <summary>
            /// ƶ
            /// </summary>
            Move,
        }
    }
}
