using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace TFramework
{
    /// <summary>
    /// ģʽ
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class SingletonBase<T> where T : class, new()
    {
        private static T _instance;

        /// <summary>
        /// ǰʵ
        /// </summary>
        public static T Instance => _instance = _instance ?? new T();

    }
}
