using TFramework;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;

namespace TFramework
{
    [CustomEditor(typeof(ObjectPoolMananger))]
    public class ObjectPoolInspector : TEditor
    {
        SerializedProperty m_poolTransform;

        private void OnEnable()
        {
            m_poolTransform = serializedObject.FindProperty("m_poolTransform");
        }

        public override void OnInspectorGUI()
        {
            serializedObject.Update();
            EditorGUILayout.PropertyField(m_poolTransform, new GUIContent("ظڵ"));
            serializedObject.ApplyModifiedProperties();
        }
    }
}
