﻿/****************************************************
    文件：TableViewItem.cs
    作者：陶长春
    邮箱：376248129@qq.com
    日期：2024年12月12日 7:56:16
    UnityVersion: 2021.3.13f1
    功能：表格视图项
*****************************************************/
using System.Collections;
using UnityEngine;
using System.Collections.Generic;
using UnityEditor.IMGUI.Controls;

namespace TFramework
{
    public class TableViewItem<T> : TreeViewItem where T :class,new()
    {
        /// <summary>
        /// 项数据
        /// </summary>
        public T Data { get; private set; }
        
		public TableViewItem(int id, int depth, T data) : base(id, depth, data == null ? "Root" : data.ToString())
        {
            Data = data;
        }
    }
}