using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace TFramework
{
    [Serializable]
    public class Behaviour : MonoBehaviour
    {
        [SerializeField, HideInInspector]
        private string m_id;

        public string ID{ 
        get => m_id = string.IsNullOrEmpty(m_id) ? gameObject.name + "_" + long.Parse(DateTime.Now.ToString("yyyyMMddhhmmss")).ToString("X") : m_id;
            protected set => m_id = value;
        } 

        public virtual void Start()
        {

        }

        /// <summary>
        /// ID 
        /// </summary>
        public void ResetID()=> ID = gameObject.name + "_" + long.Parse(DateTime.Now.ToString("yyyyMMddhhmmss")).ToString("X");

        /// <summary>
        /// 
        /// </summary>
        public void CopyButtonEvent() => GUIUtility.systemCopyBuffer = ID;


        #region ͨ
        /// <summary>
        /// ȡ
        /// </summary>
        /// <param name="index"></param>
        /// <returns></returns>
        public Transform GetChild(int index) => transform.childCount > 0 ? transform.GetChild(index) : null;

        /// <summary>
        /// ȡgameObject
        /// </summary>
        public string ObjName
        {
            get => gameObject.name;
            set => gameObject.name = value;
        }
        #endregion
    }
}
